DL_SignatureSchemeBase< INTFACE, KEY_INTFACE > Class Template Referenceabstract

Discrete Log (DL) signature scheme base implementation. More...

`#include <pubkey.h>`

Inheritance diagram for DL_SignatureSchemeBase< INTFACE, KEY_INTFACE >:

## Public Member Functions

size_t | SignatureLength () const
| Provides the signature length.
size_t | MaxRecoverableLength () const
| Provides the maximum recoverable length.
size_t | MaxRecoverableLengthFromSignatureLength (size_t signatureLength) const
| Provides the maximum recoverable length.
bool | IsProbabilistic () const
| Determines if the scheme is probabilistic.
bool | AllowNonrecoverablePart () const
| Determines if the scheme has non-recoverable part.
bool | RecoverablePartFirst () const
| Determines if the scheme allows recoverable part first.

## Detailed Description

template<class INTFACE, class KEY_INTFACE>
class DL_SignatureSchemeBase< INTFACE, KEY_INTFACE >

Discrete Log (DL) signature scheme base implementation.

Template Parameters

  INTFACE | PK_Signer or PK_Verifier derived class
  KEY_INTFACE | DL_Base key base used in the scheme

DL_SignatureSchemeBase provides common functions for signers and verifiers. DL_Base<DL_PrivateKey> is used for signers, and DL_Base<DL_PublicKey> is used for verifiers.

Definition at line 1542 of file pubkey.h.

## Constructor & Destructor Documentation

## ~DL_SignatureSchemeBase()

template<class INTFACE , class KEY_INTFACE >

virtual DL_SignatureSchemeBase< INTFACE, KEY_INTFACE >::~DL_SignatureSchemeBase | ( |  | ) |

inline virtual

Definition at line 1545 of file pubkey.h.

## Member Function Documentation

## SignatureLength()

template<class INTFACE , class KEY_INTFACE >

size_t DL_SignatureSchemeBase< INTFACE, KEY_INTFACE >::SignatureLength | ( |  | ) | const

inline

Provides the signature length.

Returns
  signature length, in bytes

SignatureLength returns the size required for `r+s`.

Definition at line 1550 of file pubkey.h.

## MaxRecoverableLength()

template<class INTFACE , class KEY_INTFACE >

size_t DL_SignatureSchemeBase< INTFACE, KEY_INTFACE >::MaxRecoverableLength | ( |  | ) | const

inline

Provides the maximum recoverable length.

Returns
  maximum recoverable length, in bytes

Definition at line 1558 of file pubkey.h.

## MaxRecoverableLengthFromSignatureLength()

template<class INTFACE , class KEY_INTFACE >

size_t DL_SignatureSchemeBase< INTFACE, KEY_INTFACE >::MaxRecoverableLengthFromSignatureLength | ( | size_t | signatureLength | ) | const

inline

Provides the maximum recoverable length.

Parameters

  signatureLength | the size of the signature

Returns
  maximum recoverable length based on signature length, in bytes

this function is not implemented and always returns 0.

Definition at line 1565 of file pubkey.h.

## IsProbabilistic()

template<class INTFACE , class KEY_INTFACE >

bool DL_SignatureSchemeBase< INTFACE, KEY_INTFACE >::IsProbabilistic | ( |  | ) | const

inline

Determines if the scheme is probabilistic.

Returns
  true if the scheme is probabilistic, false otherwise

Definition at line 1570 of file pubkey.h.

## AllowNonrecoverablePart()

template<class INTFACE , class KEY_INTFACE >

bool DL_SignatureSchemeBase< INTFACE, KEY_INTFACE >::AllowNonrecoverablePart | ( |  | ) | const

inline

Determines if the scheme has non-recoverable part.

Returns
  true if the message encoding has a non-recoverable part, false otherwise.

Definition at line 1575 of file pubkey.h.

## RecoverablePartFirst()

template<class INTFACE , class KEY_INTFACE >

bool DL_SignatureSchemeBase< INTFACE, KEY_INTFACE >::RecoverablePartFirst | ( |  | ) | const

inline

Determines if the scheme allows recoverable part first.

Returns
  true if the message encoding allows the recoverable part, false otherwise.

Definition at line 1580 of file pubkey.h.

The documentation for this class was generated from the following file:

- pubkey.h